<template>

      <div>
        <q-card>
          <q-card-title>
            <q-search v-model="searchterm" placeholder="Search" float-label="Enter search terms" v-on:keyup.enter="addsearchterm(searchterm)"/>
            <div class="row justify-center">
              <q-chip 
              closable
              v-for="(term, index) in searchterms" 
              :key="index"
              @close="removeterm(index)"
              @click="toggleterm(index)"
              :class="[term.active ? 'bg-blue text-white' : 'bg-red text-white']">{{ term.name }}</q-chip>
            </div>
          </q-card-title>
          <!-- <q-card-separator/> -->
          <q-card-main>
            <ResumeList
              :totalResults="totalresults"
              :results="results"
              :page="currentpage"
              :numPages="numpages"
              @changePage="changePage($event)"
              @select="select($event)"
            />
          </q-card-main>
        </q-card>

        <q-modal v-model.lazy="showmodal" maximized>
          <q-modal-layout>
            <q-toolbar slot="header">
              <q-btn
                flat
                round
                dense
                @click="unselect()"
                icon="reply"
                wait-for-ripple
              />
              <q-toolbar-title>
                {{ selected.name }}
              </q-toolbar-title>
            </q-toolbar>

            <div class="layout-padding q-pa-sm">
              <ResumeData
                :resume="selected"
                :chartSkills="chartskills"
              />
            </div>

          </q-modal-layout>
        </q-modal>

        <!-- <timeline :data="chartskills"></timeline> -->

      </div>

</template>

<script>
import taleanconnector from './taleanconnector'
import helper from './helper'
import {
  QBtn,
  QIcon,
  QList,
  QListHeader,
  QItem,
  QItemSide,
  QItemMain,
  QItemSeparator,
  QItemTile,
  QCard,
  QCardTitle,
  QCardSeparator,
  QCardMain,
  QSearch,
  // QChipsInput
  QChip,
  QAutocomplete,
  Loading,
  QSpinnerGears,
  QModal,
  QModalLayout,
  QToolbar,
  QToolbarTitle,
  QCollapsible,
  QPagination,
  QCheckbox
} from 'quasar'

import ResumeList from './ResumeList'
import ResumeData from './ResumeData'

export default {
  name: 'ResumeSearch',
  components: {
    QBtn,
    QIcon,
    QList,
    QListHeader,
    QItem,
    QItemSide,
    QItemMain,
    QItemSeparator,
    QItemTile,
    QCard,
    QCardTitle,
    QCardSeparator,
    QCardMain,
    QSearch,
    // QChipsInput
    QChip,
    QAutocomplete,
    Loading,
    QSpinnerGears,
    QModal,
    QModalLayout,
    QToolbar,
    QToolbarTitle,
    QCollapsible,
    QPagination,
    QCheckbox,
    ResumeList,
    ResumeData
  },
  data () {
    return {
      totalresults: 0,
      results: [],
      searchterm: '',
      searchterms: [],
      // from: 0,
      size: 15,
      showmodal: false,
      selected: {
        'skills': []
      },
      currentpage: 1
    }
  },
  created: function () {
    if (!this.$session.get('loggedin')) {
      this.$router.push('/login')
    }
    this.searchresumes()
  },
  computed: {
    selectedresumes () {
      return this.results.filter((val) => {
        return val.selected
      })
    },
    numpages () {
      return Math.ceil(this.totalresults / this.size)
    },
    from () {
      return (this.currentpage * this.size) - this.size
    },
    chartskills () {
      // return this.selected.skills.length - 1
      let ray = this.selected.skills.map((val) => {
        return [val.name, this.genDate(val.startdate), this.getDate()]
      })
      let ret = []
      for (let i = 0; i < ray.length; i++) {
        ret.push(ray[i])
      }
      return ret
    }
  },
  methods: {
    getDate () {
      let date = new Date()
      let year = date.getFullYear()
      let month = date.getMonth()
      let day = date.getDay()
      if (month < 10) {
        month = `0${month}`
      }
      if (day < 10) {
        day = `0${day}`
      }
      return `${year}-${month}-${day}`
    },
    genDate (d) {
      let date = new Date(d)
      let year = date.getFullYear()
      let month = date.getMonth()
      let day = date.getDay() + 1
      if (month < 10) {
        month = `0${month}`
      }
      if (day < 10) {
        day = `0${day}`
      }
      return `${year}-${month}-${day}`
    },
    changePage (npage) {
      this.currentpage = npage
      this.searchresumes()
    },
    searchresumes: function () {
      Loading.show({
        'delay': 10 // show in 10ms
      })
      let filteredterms = this.searchterms.filter((val) => {
        return val.active
      })
      let tsearchterms = filteredterms.map((val) => {
        return val.name
      })
      // console.log(this.from, this.size)
      taleanconnector.searchresumes(tsearchterms, this.from, this.size)
        .then((response) => {
          // console.log(response)
          this.results = response.data
          this.totalresults = response.total
          // console.log(this.results)
          Loading.hide()
        })
        .catch((err) => {
          console.log(err)
          Loading.hide()
        })
    },
    addsearchterm: function () {
      let myterms = this.searchterms.map((val) => {
        return val.name
      })
      if (this.searchterm === '' || helper.containsCaseInsensitive(myterms, this.searchterm)) {
        this.searchterm = ''
        return
      }
      this.searchterms.push({
        'name': this.searchterm,
        'active': true
      })
      this.searchterm = ''
      // this.currentpage = 1
      this.searchresumes()
    },
    toggleterm: function (index) {
      this.searchterms[index].active = !this.searchterms[index].active
      this.searchresumes()
    },
    removeterm: function (index) {
      this.searchterms.splice(index, 1)
      this.searchresumes()
    },
    select: function (item) {
      this.selected = item
      this.showmodal = true
      console.log(this.chartskills)
      console.log(this.getDate())
      console.log(new Date(this.selected.skills[0].startdate))
      // console.log(this.selected)
    },
    unselect: function () {
      this.selected = {
        'skills': []
      }
      this.showmodal = false
    }
  },
  mounted () {
  },
  beforeDestroy () {
  }
}
</script>

<style lang="stylus">
</style>
